<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Tower Attack: CTower Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Tower Attack
   </div>
   <div id="projectbrief">A simple console game</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classCTower-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CTower Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Tower is one of the main game objects, it can attack and defend itself from other attackers, it remembers it's position, can save itself to a file and clones itself.  
 <a href="classCTower.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="entities_8h_source.html">entities.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for CTower:</div>
<div class="dyncontent">
<div class="center"><img src="classCTower__inherit__graph.png" border="0" usemap="#CTower_inherit__map" alt="Inheritance graph"/></div>
<map name="CTower_inherit__map" id="CTower_inherit__map">
<area shape="rect" id="node3" href="classCArtillery.html" title="ARTILLERY 25% Chance of larger distance by half 20% Chance of double shot. " alt="" coords="5,155,81,181"/>
<area shape="rect" id="node4" href="classCHeavy.html" title="HEAVY 20% chance of blocking all attacks 10% chance of damage to attacker when hit. " alt="" coords="105,155,176,181"/>
<area shape="rect" id="node5" href="classCMedic.html" title="MEDIC 20% chance of blocking attack coming from Warrior 33% chance of surviving death and restoring 1..." alt="" coords="201,155,267,181"/>
<area shape="rect" id="node2" href="classCEntity.html" title="Abstract class, used to store entities to map. " alt="" coords="107,5,174,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for CTower:</div>
<div class="dyncontent">
<div class="center"><img src="classCTower__coll__graph.png" border="0" usemap="#CTower_coll__map" alt="Collaboration graph"/></div>
<map name="CTower_coll__map" id="CTower_coll__map">
<area shape="rect" id="node2" href="classCEntity.html" title="Abstract class, used to store entities to map. " alt="" coords="5,5,72,32"/>
<area shape="rect" id="node3" href="structTCoord.html" title="Coordinates, row and col. " alt="" coords="97,5,162,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a8634f96b7e6985fac9ef1d3dbea46651"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#a8634f96b7e6985fac9ef1d3dbea46651">CTower</a> (char symbol, const string &amp;name, int hp, int <a class="el" href="classCTower.html#a28666cdfbf94e1b025e2fe85595d9d96">attack</a>, int range, int parentID)</td></tr>
<tr class="memdesc:a8634f96b7e6985fac9ef1d3dbea46651"><td class="mdescLeft">&#160;</td><td class="mdescRight">Tower constructor, sets member variables.  <a href="#a8634f96b7e6985fac9ef1d3dbea46651">More...</a><br /></td></tr>
<tr class="separator:a8634f96b7e6985fac9ef1d3dbea46651"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a276726c55954b273f6b25e6ef749b01d"><td class="memItemLeft" align="right" valign="top"><a id="a276726c55954b273f6b25e6ef749b01d"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#a276726c55954b273f6b25e6ef749b01d">print</a> (ostream &amp;os) const</td></tr>
<tr class="memdesc:a276726c55954b273f6b25e6ef749b01d"><td class="mdescLeft">&#160;</td><td class="mdescRight">virtual destructor <br /></td></tr>
<tr class="separator:a276726c55954b273f6b25e6ef749b01d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d218d5d19849b04697699b17ba856e9"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#a5d218d5d19849b04697699b17ba856e9">printDetails</a> (ostream &amp;os) const</td></tr>
<tr class="memdesc:a5d218d5d19849b04697699b17ba856e9"><td class="mdescLeft">&#160;</td><td class="mdescRight">prints the symbol of the tower  <a href="#a5d218d5d19849b04697699b17ba856e9">More...</a><br /></td></tr>
<tr class="separator:a5d218d5d19849b04697699b17ba856e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab6fce3e9fc4c2c3b57c0a8be35f6c055"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#ab6fce3e9fc4c2c3b57c0a8be35f6c055">save</a> (ofstream &amp;ofs) const</td></tr>
<tr class="memdesc:ab6fce3e9fc4c2c3b57c0a8be35f6c055"><td class="mdescLeft">&#160;</td><td class="mdescRight">Save tower to stream given by parameter.  <a href="#ab6fce3e9fc4c2c3b57c0a8be35f6c055">More...</a><br /></td></tr>
<tr class="separator:ab6fce3e9fc4c2c3b57c0a8be35f6c055"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0fefddb0e945dde74c48a5aff1a15e4"><td class="memItemLeft" align="right" valign="top"><a id="ac0fefddb0e945dde74c48a5aff1a15e4"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>setPos</b> (<a class="el" href="structTCoord.html">TCoord</a> pos)</td></tr>
<tr class="separator:ac0fefddb0e945dde74c48a5aff1a15e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a682eee406b527e183153ca7b9ef74301"><td class="memItemLeft" align="right" valign="top"><a id="a682eee406b527e183153ca7b9ef74301"></a>
<a class="el" href="structTCoord.html">TCoord</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#a682eee406b527e183153ca7b9ef74301">position</a> () const</td></tr>
<tr class="memdesc:a682eee406b527e183153ca7b9ef74301"><td class="mdescLeft">&#160;</td><td class="mdescRight">setter for position of the tower <br /></td></tr>
<tr class="separator:a682eee406b527e183153ca7b9ef74301"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af75495fa398d62acb73f336de801c402"><td class="memItemLeft" align="right" valign="top"><a id="af75495fa398d62acb73f336de801c402"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#af75495fa398d62acb73f336de801c402">getHp</a> () const</td></tr>
<tr class="memdesc:af75495fa398d62acb73f336de801c402"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for position of the tower <br /></td></tr>
<tr class="separator:af75495fa398d62acb73f336de801c402"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a19b4b2e8b3bee08db6c8c206a8616653"><td class="memItemLeft" align="right" valign="top"><a id="a19b4b2e8b3bee08db6c8c206a8616653"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#a19b4b2e8b3bee08db6c8c206a8616653">setHp</a> (int hp)</td></tr>
<tr class="memdesc:a19b4b2e8b3bee08db6c8c206a8616653"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for health <br /></td></tr>
<tr class="separator:a19b4b2e8b3bee08db6c8c206a8616653"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0ec399abc6a105f4e2743d65cb5d09c"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#ad0ec399abc6a105f4e2743d65cb5d09c">defend</a> (<a class="el" href="classCAttacker.html">CAttacker</a> &amp;src)</td></tr>
<tr class="memdesc:ad0ec399abc6a105f4e2743d65cb5d09c"><td class="mdescLeft">&#160;</td><td class="mdescRight">setter for health  <a href="#ad0ec399abc6a105f4e2743d65cb5d09c">More...</a><br /></td></tr>
<tr class="separator:ad0ec399abc6a105f4e2743d65cb5d09c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a937738b2359258a5bc50105e51fddb1c"><td class="memItemLeft" align="right" valign="top"><a id="a937738b2359258a5bc50105e51fddb1c"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#a937738b2359258a5bc50105e51fddb1c">defend</a> (<a class="el" href="classCWarrior.html">CWarrior</a> &amp;src)</td></tr>
<tr class="memdesc:a937738b2359258a5bc50105e51fddb1c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default defend method against warrior. <br /></td></tr>
<tr class="separator:a937738b2359258a5bc50105e51fddb1c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a28666cdfbf94e1b025e2fe85595d9d96"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#a28666cdfbf94e1b025e2fe85595d9d96">attack</a> (<a class="el" href="classCAttacker.html">CAttacker</a> &amp;dst)</td></tr>
<tr class="memdesc:a28666cdfbf94e1b025e2fe85595d9d96"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default attack method of the tower.  <a href="#a28666cdfbf94e1b025e2fe85595d9d96">More...</a><br /></td></tr>
<tr class="separator:a28666cdfbf94e1b025e2fe85595d9d96"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c7921a4507c8e9926f6ca5100df7a56"><td class="memItemLeft" align="right" valign="top"><a id="a0c7921a4507c8e9926f6ca5100df7a56"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>getAttack</b> () const</td></tr>
<tr class="separator:a0c7921a4507c8e9926f6ca5100df7a56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a205833c18de6141f52342426bf0f0fbd"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#a205833c18de6141f52342426bf0f0fbd">hasInRange</a> (const <a class="el" href="structTCoord.html">TCoord</a> &amp;src) const</td></tr>
<tr class="memdesc:a205833c18de6141f52342426bf0f0fbd"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for attack strength  <a href="#a205833c18de6141f52342426bf0f0fbd">More...</a><br /></td></tr>
<tr class="separator:a205833c18de6141f52342426bf0f0fbd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3c1dfea7f05f7ba6eb0f797c38b5a1e4"><td class="memItemLeft" align="right" valign="top"><a id="a3c1dfea7f05f7ba6eb0f797c38b5a1e4"></a>
virtual <a class="el" href="classCTower.html">CTower</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>clone</b> () const =0</td></tr>
<tr class="separator:a3c1dfea7f05f7ba6eb0f797c38b5a1e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classCEntity"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classCEntity')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classCEntity.html">CEntity</a></td></tr>
<tr class="memitem:a9ab2d129368e2d3acfec883129439e1c inherit pub_methods_classCEntity"><td class="memItemLeft" align="right" valign="top"><a id="a9ab2d129368e2d3acfec883129439e1c"></a>
virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCEntity.html#a9ab2d129368e2d3acfec883129439e1c">discover</a> () const</td></tr>
<tr class="memdesc:a9ab2d129368e2d3acfec883129439e1c inherit pub_methods_classCEntity"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the field is discoverable ( if it's either free space or path ) <br /></td></tr>
<tr class="separator:a9ab2d129368e2d3acfec883129439e1c inherit pub_methods_classCEntity"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5bedcc5d44f5b4a65d8abd8bc7766588 inherit pub_methods_classCEntity"><td class="memItemLeft" align="right" valign="top"><a id="a5bedcc5d44f5b4a65d8abd8bc7766588"></a>
virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCEntity.html#a5bedcc5d44f5b4a65d8abd8bc7766588">isPath</a> () const</td></tr>
<tr class="memdesc:a5bedcc5d44f5b4a65d8abd8bc7766588 inherit pub_methods_classCEntity"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints the object ( it's symbol ) <br /></td></tr>
<tr class="separator:a5bedcc5d44f5b4a65d8abd8bc7766588 inherit pub_methods_classCEntity"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a833f1423fd7e0f2096517b100c44db72 inherit pub_methods_classCEntity"><td class="memItemLeft" align="right" valign="top"><a id="a833f1423fd7e0f2096517b100c44db72"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCEntity.html#a833f1423fd7e0f2096517b100c44db72">~CEntity</a> ()=default</td></tr>
<tr class="memdesc:a833f1423fd7e0f2096517b100c44db72 inherit pub_methods_classCEntity"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the field is path or not. <br /></td></tr>
<tr class="separator:a833f1423fd7e0f2096517b100c44db72 inherit pub_methods_classCEntity"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a9354f89fd0276ad86e44634043fcb9ea"><td class="memItemLeft" align="right" valign="top"><a id="a9354f89fd0276ad86e44634043fcb9ea"></a>
<a class="el" href="structTCoord.html">TCoord</a>&#160;</td><td class="memItemRight" valign="bottom"><b>m_pos</b></td></tr>
<tr class="separator:a9354f89fd0276ad86e44634043fcb9ea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa9e4a1953f67cdfb457bc36200fd945"><td class="memItemLeft" align="right" valign="top"><a id="afa9e4a1953f67cdfb457bc36200fd945"></a>
char&#160;</td><td class="memItemRight" valign="bottom"><b>m_symbol</b></td></tr>
<tr class="separator:afa9e4a1953f67cdfb457bc36200fd945"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c68c17a668a9a84446af629a74c98e6"><td class="memItemLeft" align="right" valign="top"><a id="a5c68c17a668a9a84446af629a74c98e6"></a>
string&#160;</td><td class="memItemRight" valign="bottom"><b>m_name</b></td></tr>
<tr class="separator:a5c68c17a668a9a84446af629a74c98e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a15f299f53faf60c5454e093e6d30d219"><td class="memItemLeft" align="right" valign="top"><a id="a15f299f53faf60c5454e093e6d30d219"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_hp</b></td></tr>
<tr class="separator:a15f299f53faf60c5454e093e6d30d219"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9280c41f5510c939b0acac1bbfe5c88a"><td class="memItemLeft" align="right" valign="top"><a id="a9280c41f5510c939b0acac1bbfe5c88a"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_attack</b></td></tr>
<tr class="separator:a9280c41f5510c939b0acac1bbfe5c88a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a021cb7062d04e72bf0854e9a04182e6a"><td class="memItemLeft" align="right" valign="top"><a id="a021cb7062d04e72bf0854e9a04182e6a"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_range</b></td></tr>
<tr class="separator:a021cb7062d04e72bf0854e9a04182e6a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8635278c126334397380af3026d6f8a3"><td class="memItemLeft" align="right" valign="top"><a id="a8635278c126334397380af3026d6f8a3"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_parentID</b></td></tr>
<tr class="separator:a8635278c126334397380af3026d6f8a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:a6a9882d45b96e308ef3423464ba294c8"><td class="memItemLeft" align="right" valign="top">ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCTower.html#a6a9882d45b96e308ef3423464ba294c8">operator&lt;&lt;</a> (ostream &amp;os, const <a class="el" href="classCTower.html">CTower</a> &amp;tower)</td></tr>
<tr class="memdesc:a6a9882d45b96e308ef3423464ba294c8"><td class="mdescLeft">&#160;</td><td class="mdescRight">virtual clone method  <a href="#a6a9882d45b96e308ef3423464ba294c8">More...</a><br /></td></tr>
<tr class="separator:a6a9882d45b96e308ef3423464ba294c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Tower is one of the main game objects, it can attack and defend itself from other attackers, it remembers it's position, can save itself to a file and clones itself. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a8634f96b7e6985fac9ef1d3dbea46651"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8634f96b7e6985fac9ef1d3dbea46651">&#9670;&nbsp;</a></span>CTower()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CTower::CTower </td>
          <td>(</td>
          <td class="paramtype">char&#160;</td>
          <td class="paramname"><em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>hp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>attack</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>range</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>parentID</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Tower constructor, sets member variables. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">symbol</td><td></td></tr>
    <tr><td class="paramname">name</td><td></td></tr>
    <tr><td class="paramname">hp</td><td>health </td></tr>
    <tr><td class="paramname">how</td><td>much damage can tower cause </td></tr>
    <tr><td class="paramname">range</td><td>how far does it see </td></tr>
    <tr><td class="paramname">parentID</td><td>who is it's template ( parent ) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a28666cdfbf94e1b025e2fe85595d9d96"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a28666cdfbf94e1b025e2fe85595d9d96">&#9670;&nbsp;</a></span>attack()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CTower::attack </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classCAttacker.html">CAttacker</a> &amp;&#160;</td>
          <td class="paramname"><em>dst</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Default attack method of the tower. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dst</td><td>Attacker to attack </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classCArtillery.html#a5ba90dd07f54e0aa4f30aea9d19fb784">CArtillery</a>, <a class="el" href="classCHeavy.html#a3b2fe70331aa648035c8a80a7f791647">CHeavy</a>, and <a class="el" href="classCMedic.html#a575d27ab551eda2d24c21ffd13d36992">CMedic</a>.</p>

</div>
</div>
<a id="ad0ec399abc6a105f4e2743d65cb5d09c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad0ec399abc6a105f4e2743d65cb5d09c">&#9670;&nbsp;</a></span>defend()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CTower::defend </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classCAttacker.html">CAttacker</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>setter for health </p>
<p>Default defend method of the tower.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>Attacker that attacks this tower </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classCHeavy.html#aa0b1363684f510a1f0a735743cd00d38">CHeavy</a>, and <a class="el" href="classCMedic.html#affc33dec9653626ccd0fd70af6aab943">CMedic</a>.</p>

</div>
</div>
<a id="a205833c18de6141f52342426bf0f0fbd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a205833c18de6141f52342426bf0f0fbd">&#9670;&nbsp;</a></span>hasInRange()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CTower::hasInRange </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structTCoord.html">TCoord</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>getter for attack strength </p>
<p>Returns whether the given coordinates are in tower's range.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>coordinates to compare </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>if the src coordinates are in range </dd></dl>

<p>Reimplemented in <a class="el" href="classCArtillery.html#a6a09e0b4902b9a2cea04a356f97c0d5b">CArtillery</a>.</p>

</div>
</div>
<a id="a5d218d5d19849b04697699b17ba856e9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d218d5d19849b04697699b17ba856e9">&#9670;&nbsp;</a></span>printDetails()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CTower::printDetails </td>
          <td>(</td>
          <td class="paramtype">ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>prints the symbol of the tower </p>
<p>Prints tower details to stream. </p>

<p>Reimplemented in <a class="el" href="classCArtillery.html#ac8bfde1a7b6645f026ac2bc612263cbc">CArtillery</a>, <a class="el" href="classCHeavy.html#aa40d8a34f4b6b402bf12b483f444c6d0">CHeavy</a>, and <a class="el" href="classCMedic.html#a7a42d9dd8c6da4bdc436806440ce6b96">CMedic</a>.</p>

</div>
</div>
<a id="ab6fce3e9fc4c2c3b57c0a8be35f6c055"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab6fce3e9fc4c2c3b57c0a8be35f6c055">&#9670;&nbsp;</a></span>save()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CTower::save </td>
          <td>(</td>
          <td class="paramtype">ofstream &amp;&#160;</td>
          <td class="paramname"><em>ofs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Save tower to stream given by parameter. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ofs</td><td>stream to save tower into </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="a6a9882d45b96e308ef3423464ba294c8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6a9882d45b96e308ef3423464ba294c8">&#9670;&nbsp;</a></span>operator<<</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classCTower.html">CTower</a> &amp;&#160;</td>
          <td class="paramname"><em>tower</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>virtual clone method </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">tower</td><td>to print </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="entities_8h_source.html">entities.h</a></li>
<li>entities.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
